/*
              HEADER FILE FOR DISK_READ & DISK_WRITE ROUTINES

     This file contains definitions that programs using disk_read and
disk_write might find useful to know.
*/

#define MAX_CHANNELS		 16   /* max # of channels open for reading */
#define MAX_FILES		 10   /* max # of files open for writing */
#define MAX_VARS_PER_BLK	 36   /* max # of variables per block */
#define MAX_VALUES_PER_VAR     4096   /* max # of values per block variable */
#define MAX_VARNAME_LENG	 16   /* max # of characters in a variable name,
                                         not including null termination */
#define MAX_FILENAME_LENG	 80   /* max # of characters in a file name,
                                         not including null termination */

#define SHORT	1	/* definition of short data type */
#define INT	2	/* definition of   int data type */
#define FLOAT	3	/* definition of float data type */

#define DISK_IO_EOF   -5  /* function return value for EOF error */
